#define NULE 0
#define RULE 1

typedef struct NOiD_empty
{
	int size;
	struct NOiD_empty * last;
	struct NOiD_empty * next;
} NOiD_empty;

NOiD_empty * NOiD_seg (void * noid_array, int noid_size)
{
	NOiD_empty * noid_new = (NOiD_empty*)(noid_array);
	noid_new->size = noid_size;
	noid_new->last = noid_new;
	noid_new->next = (NOiD_empty * ) (noid_array + sizeof(NOiD_empty));
	noid_new->next->size = noid_size - sizeof(NOiD_empty) - sizeof(NOiD_empty);
	noid_new->next->next = (NOiD_empty * ) noid_array;
	noid_new->next->last = (NOiD_empty * ) noid_array;
	return noid_new;
}

void * NOiD_alloc (NOiD_empty * noid_array, int noid_size)
{
	if ((noid_size > noid_array->next->size - sizeof(NOiD_empty))||(noid_size < sizeof(NOiD_empty)))
	{	return NULE;	}

	NOiD_empty * noid_old = noid_array->next;
	while (noid_old->next != noid_array)
	{
		if (noid_old->size < noid_size)
		{	return NULE;	}
		noid_old->next;
	}

	/*the most bizzard bug ever , if i add 1 to (noid_empty*) type , it add sizeof(noid_empty)*/
	NOiD_empty * noid_new = (NOiD_empty*)((void*)noid_old + sizeof(int) + noid_size);
	void * noid_now = (void*)(noid_array->next);

	noid_new->size = noid_array->next->size - noid_size - sizeof(int);
	noid_new->last = noid_array->next->last;
	noid_new->next = noid_array->next->next;
	noid_array->next = noid_new;

	*(int*)noid_now = noid_size;
	noid_now += sizeof(int);
	*(int*)noid_now = 0;
	*(int*)(noid_now + sizeof(int)) = 0;

	return noid_now;
	//return (void*)noid_new;
}

void NOiD_free ()
{

}

